        TITLE   'BT 100'
; *************************************
;
;           OVLADANI TISKARNY
;
;                 BT 100
;
; BT.ASM                         BT.HEX
;
; 31.01.1990
;
; -------------------------------------
;       REGISTRY PRO TISK
; RB0 - R0      ADRESA BUFF.TISK L
;       R1      PULSY PRI OTOC - PAMET
;       R2      PULSY PRI OTOC - NAVIC
;       R3      UNIVERSAL
;       R4      POCET ZNAKU
;       R5      ROTACE ZNAKU
;       R6      ADRESA BUFF.TISK H
;       R7      AKT. RADEK GENERATORU
;
;       REGISTRY PRO PAMET
; RB1 - R0
;       R1
;       R2
;       R3      POCET ZNAKU
;       R4      ADRESA BUFF.TISK L
;       R5      ADRESA BUFF.TISK H
;       R6      ADRESA BUFF.ZAPIS L
;       R7      ADRESA BUFF.ZAPIS H
;
; F0  - '0'     JEDNOSMERNY
;     - '1'     OBOUSMERNY
; F1  - '0'     ASCII
;     - '1'     GRAFICKY
; -------------------------------------
;
        ORG     000H
;
INI     SEL     RB0
        MOV     A,0FH
        OUTL    P1,A
        CLR     F0
        NOP
        CLR     F1
        CLR     A
        OUTL    P2,A
        SEL     RB1
        MOV     R4,A
        MOV     R5,A
        MOV     R6,A
        MOV     R7,A
        SEL     RB0
        MOV     R0,A
        MOV     R1,#07H
        MOV     R6,#0C0H
;
        ORG     070H
;
; TISK CELEHO RADKU
;
TISK:   CLR     A
        MOV     R7,A
        MOV     R4,A
TISK1:  CALL    VPR1
TISK2:  MOV     A,R6
        OUTL    P2,A
        MOVX    A,@R0
        ADD     A,#00
        JZ      TISK10
        CALL    HLED
        CALL    BP
        INC     R0
        MOV     A,R0
        ADD     A,#00
        JZ      TISK4
TISK3:  INC     R4
        MOV     A,R4
        ADD     A,#0B0H
        JC      TISK10
        JMP     TISK2
TISK4:  MOV     A,R6
        INC     A
        ANL     A,#11110111B
        MOV     R6,A
        JMP     TISK3
TISK5:  INC     R7
        CALL    OTOC
TISK6:  MOV     A,R0
        DEC     R0
        ADD     A,#00
        JZ      TISK9
TISK7:  MOV     A,R6
        OUTL    P2,A
        MOVX    A,@R0
        CALL    HLED
        RLC     A
        RLC     A
        CALL    BV
        DJNZ    R4,TISK6
TISK8:  INC     R7
        MOV     A,R7
        ADD     A,#0F5H
        CALL    V1
        JNC     TISK1
        RET
TISK9:  MOV     A,R6
        ORL     A,#00001000B
        DEC     A
        ANL     A,#11110111B
        MOV     R6,A
        JMP     TISK7
TISK10: MOV     A,R4
        SEL     RB1
        MOV     R3,A
        SEL     RB0
        JF1     TISK11
        JF0     TISK5
        SEL     RB1
        MOV     A,R6
        SEL     RB0
        MOV     R0,A
        SEL     RB1
        MOV     A,R7
        SEL     RB0
        MOV     R6,A
        JMP     TISK8
TISK11: CALL    V1
        RET
;
; HLEDANI V TABULCE
;
HLED:   JF1     T0
        MOV     R3,#0ECH
        ADD     A,#0E0H
        JNC     T0
        ADD     A,R3
        JNC     T1
        ADD     A,R3
        JNC     T2
        ADD     A,R3
        JNC     T3
        ADD     A,R3
        JNC     T4
        ADD     A,R3
        JNC     T5
        ADD     A,R3
        JNC     T6
        ADD     A,R3
        JNC     T7
T0:     RET
T1:     JMP     S1
T2:     JMP     S2
T3:     JMP     S3
T4:     JMP     S4
T5:     JMP     S5
T6:     JMP     S6
T7:     JMP     S7
;
        ORG     1F0H
; VYPOCET ADRESY KODU
S1      ADD     A,#14H
        RL      A
        RL      A
        MOV     R3,A
        RL      A
        ADD     A,R3
        ADD     A,R7
        MOVP    A,@A
        RET
;
        ORG     2F0H
; VYPOCET ADRESY KODU
S2      ADD     A,#14H
        RL      A
        RL      A
        MOV     R3,A
        RL      A
        ADD     A,R3
        ADD     A,R7
        MOVP    A,@A
        RET
;
        ORG     3F0H
; VYPOCET ADRESY KODU
S3      ADD     A,#14H
        RL      A
        RL      A
        MOV     R3,A
        RL      A
        ADD     A,R3
        ADD     A,R7
        MOVP    A,@A
        RET
;
        ORG     4F0H
; VYPOCET ADRESY KODU
S4      ADD     A,#14H
        RL      A
        RL      A
        MOV     R3,A
        RL      A
        ADD     A,R3
        ADD     A,R7
        MOVP    A,@A
        RET
;
        ORG     5F0H
; VYPOCET ADRESY KODU
S5      ADD     A,#14H
        RL      A
        RL      A
        MOV     R3,A
        RL      A
        ADD     A,R3
        ADD     A,R7
        MOVP    A,@A
        RET
;
        ORG     6F0H
; VYPOCET ADRESY KODU
S6      ADD     A,#14H
        RL      A
        RL      A
        MOV     R3,A
        RL      A
        ADD     A,R3
        ADD     A,R7
        MOVP    A,@A
        RET
;
        ORG     76DH
; VYPOCET ADRESY KODU
S7      ADD     A,#14H
        RL      A
        RL      A
        MOV     R3,A
        RL      A
        ADD     A,R3
        ADD     A,R7
        MOVP    A,@A
        RET
;
;
; TISK SESTICE BODU VPRAVO
BP:     MOV     R3,#06H
BP1:    IN      A,P1
        CPL     A
        JB2     BP1
        MOV     A,R5
        RRC     A
        MOV     R5,A
        JNC     BP2
        MOV     A,#01011111B
        OUTL    P1,A
        MOV     A,#00011111B
        OUTL    P1,A
BP2:    IN      A,P1
        NOP
        JB2     BP2
        DJNZ    R3,BP1
        RET
;
;
; TISK SESTICE BODU VLEVO
BV:     MOV     R3,#06H
BV1:    IN      A,P1
        NOP
        JB2     BV1
        MOV     A,R5
        RLC     A
        MOV     R5,A
        JNC     BV2
        MOV     A,#01101111B
        OUTL    P1,A
        MOV     A,#00101111B
        OUTL    P1,A
BV2:    IN      A,P1
        CPL     A
        JB2     BV2
        DJNZ    R3,BV1
        RET
; POJEZD VOZIKU
V1:     MOV     A,#10001111B
        OUTL    P1,A
        IN      A,P1
        JB3     V3
V2:     IN      A,P1
        CPL     A
        JB3     V2
        JMP     V4
V3:     IN      A,P1
        JB3     V3
V4:     MOV     A,#00001111B
        OUTL    P1,A
        RET
; POJEZD VPRAVO + START
VPR1:   MOV     A,#00101111B
        OUTL    P1,A
VPR2:   IN      A,P1
        NOP
        JB0     VPR2
        MOV     A,#00011111B
        OUTL    P1,A
VPR3:   IN      A,P1
        CPL     A
        JB1     VPR3
VPR4:   IN      A,P1
        NOP
        JB1     VPR4
        RET
; OTOCKA + VLEVO
OTOC:   MOV     A,R1
        MOV     R3,A
OTOC1:  IN      A,P1
        CPL     A
        JB2     OTOC1
OTOC2:  IN      A,P1
        JB2     OTOC2
        DJNZ    R3,OTOC1
OTOC3:  IN      A,P1
        JB1     OTOC5
        JB2     OTOC3
OTOC4:  IN      A,P1
        CPL     A
        JB2     OTOC4
        INC     R2
        INC     R3
        JMP     OTOC3
OTOC5:  CALL    V1
        MOV     A,#00101111B
        OUTL    P1,A
OTOC6:  IN      A,P1
        CPL     A
        JB1     OTOC6
OTOC7:  IN      A,P1
        NOP
        JB1     OTOC7
        INC     R2
OTOC8:  DJNZ    R2,OTOC9
        RET
OTOC9:  IN      A,P1
        CPL     A
        JB2     OTOC9
OTOC10: IN      A,P1
        NOP
        JB2     OTOC10
        JMP     OTOC8
;
;
        END
